
INCLUDE PCMAC.INC

DATSEG  SEGMENT WORD PUBLIC 'DATA'
DATSEG  ENDS
CODSEG  SEGMENT WORD PUBLIC 'CODE'
CODSEG  ENDS

DGROUP  GROUP DATSEG

DATSEG  SEGMENT WORD PUBLIC 'DATA'
Sign    DB      ?
Counter DB      ?
DATSEG  ENDS

CODSEG  SEGMENT WORD PUBLIC 'CODE'
ASSUME  cs:CODSEG, ds:DGROUP, ss:DGROUP
PUBLIC	GetDec
GetDec	PROC
	push    bx
        push    cx
        push    dx
        mov     Counter, 0
        mov     bx, 0
        mov     cx, 10
        mov     Sign, '+'
        _GetCh
        cmp     al, '-'
        jne     AfterRead
        mov     Sign, '-'
ReadLoop:
        _GetCh
AfterRead:
        cmp     al, '0'
        jl      Done
        cmp     al, '9'
        jg      Done
        sub     al, '0'
        mov     ah, 0
        inc     Counter
        xchg    ax, bx
        mul     cx
        jo      Error
        add     ax, bx
        mov     bx, ax
        jc      Error
        jmp     ReadLoop
Done:
        cmp     al, 13
        jne     NoLF
        _PutCh  10
NoLF:
        cmp     Counter, 0
        je      Error
        cmp bx, 8000h
        ja      Error
        jne     OK
        cmp     Sign, '-'
        je      Positive
Error:
        stc
        jmp     Return
OK:
        cmp     Sign, '-'
        jne     Positive
        neg     bx
Positive:
        mov     ax, bx
        clc
Return:
        pop     dx
        pop     cx
        pop     bx
        ret
GetDec  ENDP
CODSEG  ENDS
END
